package tp3.atmsystem;

public class ATMSystem {
	
    private CardController cardController;
    private Bank bank;
    private CashDispenser cashDispenser;

    public ATMSystem(Bank bank) {
        this.cardController = new CardController();
        this.bank = bank;
        this.cashDispenser = new CashDispenser();
    }

    public boolean authenticateUser(int cardNumber, int pin) { // Correction des types
        System.out.println("Authenticating user...");
        if (cardController.validateCard(cardNumber)) {
            boolean isValid = bank.verifyPin(cardNumber, pin);
            if (isValid) {
                System.out.println("Authentication successful.");
                return true;
            } else {
                System.out.println("Invalid PIN.");
            }
        } else {
            System.out.println("Invalid card.");
        }
        return false;
    }

    public boolean withdraw(int cardNumber, double amount) { 
        System.out.println("Processing withdrawal of $" + amount + "...");
        if (bank.checkBalance(cardNumber, amount)) {
        	cashDispenser.dispense(amount);
            bank.updateBalance(cardNumber, -amount);
            System.out.println("Withdrawal successful.");
            return true;
        } else {
            System.out.println("Insufficient funds.");
            return false;
        }
    }
    
    public boolean validateCard(int cardNumber) {
    	return cardController.validateCard(cardNumber);
    }
}
