package tp3.atmsystem;
import java.util.HashMap;

public class Bank {
	
	private HashMap<Integer, Account> accounts;
	
	public Bank() {
		accounts = new HashMap<>();
	}
	

	public void addAccount(String accountNumber, int cardNumber, int pin, double initialBalance) {
        accounts.put(cardNumber, new Account(accountNumber, cardNumber, pin, initialBalance));
    }
	

	public boolean verifyPin(int cardNumber, int pin) {
        Account account = accounts.get(cardNumber);
        if (account != null) {
            return account.getPin() == pin;
        }
        return false;
    }
	

	public boolean checkBalance(int cardNumber, double amount) {
        Account account = accounts.get(cardNumber);
        if (account != null) {
            return account.getBalance() >= amount;
        }
        return false;
    }

	public boolean updateBalance(int cardNumber, double amount) {
        Account account = accounts.get(cardNumber);
        if (account != null) {
            account.updateBalance(amount);
            return true;
        }
        return false;
    }
}
